| Haskell Core Libraries (Cabal package) | Contents | Index

Distribution.Setup

Portability | portable
Stability | alpha
Maintainer | Isaac Jones <ijones@syntaxpolice.org>

Description
Explanation: Data types and parser for the standard command-line setup. Will also return commands it doesn't know about.
Synopsis

module Distribution.Compiler

data Action

= ConfigCmd ConfigFlags
| BuildCmd
| CleanCmd
| CopyCmd CopyDest
| HaddockCmd
| ProgramaticaCmd
| InstallCmd InstallUserFlag
| SDistCmd
| TestCmd
| RegisterCmd Bool Bool
| UnregisterCmd Bool Bool
| HelpCmd

data ConfigFlags = ConfigFlags {

configPrograms :: ProgramConfiguration
configHcFlavor :: (Maybe CompilerFlavor)
configHcPath :: (Maybe FilePath)
configHcPkg :: (Maybe FilePath)
configHappy :: (Maybe FilePath)
configAlex :: (Maybe FilePath)
configHsc2hs :: (Maybe FilePath)
configC2hs :: (Maybe FilePath)
configCpphs :: (Maybe FilePath)
configGreencard :: (Maybe FilePath)
configProfLib :: Bool
configProfExe :: Bool
configPrefix :: (Maybe FilePath)
configBinDir :: (Maybe FilePath)
configLibDir :: (Maybe FilePath)
configLibSubDir :: (Maybe FilePath)
configLibExecDir :: (Maybe FilePath)
configDataDir :: (Maybe FilePath)
configDataSubDir :: (Maybe FilePath)
configVerbose :: Int
configUser :: Bool
configGHCiLib :: Bool

}

emptyConfigFlags :: ProgramConfiguration -> ConfigFlags
configureArgs :: ConfigFlags -> [String]
type CopyFlags = (CopyDest, Int)

data CopyDest

= NoCopyDest
| CopyTo FilePath
| CopyPrefix FilePath

type InstallFlags = (InstallUserFlag, Int)
type RegisterFlags = (Bool, Bool, Int)
type SDistFlags = (Bool, Int)

data InstallUserFlag

= InstallUserNone
| InstallUserUser
| InstallUserGlobal

parseGlobalArgs :: ProgramConfiguration -> [String] -> IO (Action, [String])
defaultCompilerFlavor :: Maybe CompilerFlavor
parseConfigureArgs :: ProgramConfiguration -> ConfigFlags -> [String] -> [OptDescr a] -> IO (ConfigFlags, [a], [String])
parseBuildArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseCleanArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseHaddockArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseProgramaticaArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseTestArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseInstallArgs :: InstallFlags -> [String] -> [OptDescr a] -> IO (InstallFlags, [a], [String])
parseSDistArgs :: [String] -> [OptDescr a] -> IO (SDistFlags, [a], [String])
parseRegisterArgs :: RegisterFlags -> [String] -> [OptDescr a] -> IO (RegisterFlags, [a], [String])
parseUnregisterArgs :: RegisterFlags -> [String] -> [OptDescr a] -> IO (RegisterFlags, [a], [String])
parseCopyArgs :: CopyFlags -> [String] -> [OptDescr a] -> IO (CopyFlags, [a], [String])
reqPathArg :: (FilePath -> a) -> ArgDescr a
reqDirArg :: (FilePath -> a) -> ArgDescr a

Documentation
module Distribution.Compiler
data Action

Constructors

ConfigCmd ConfigFlags |
BuildCmd |
CleanCmd |
CopyCmd CopyDest |
HaddockCmd |
ProgramaticaCmd |
InstallCmd InstallUserFlag |
SDistCmd |
TestCmd |
RegisterCmd Bool Bool |
UnregisterCmd Bool Bool |
HelpCmd |

data ConfigFlags

Flags to `configure` command
Constructors

ConfigFlags |

configPrograms :: ProgramConfiguration | All programs that cabal may run
configHcFlavor :: (Maybe CompilerFlavor) |
configHcPath :: (Maybe FilePath) | given compiler location
configHcPkg :: (Maybe FilePath) | given hc-pkg location
configHappy :: (Maybe FilePath) | Happy path
configAlex :: (Maybe FilePath) | Alex path
configHsc2hs :: (Maybe FilePath) | Hsc2hs path
configC2hs :: (Maybe FilePath) | C2hs path
configCpphs :: (Maybe FilePath) | Cpphs path
configGreencard :: (Maybe FilePath) | GreenCard path
configProfLib :: Bool | Enable profiling in the library
configProfExe :: Bool | Enable profiling in the executables.
configPrefix :: (Maybe FilePath) | installation prefix
configBinDir :: (Maybe FilePath) | installation dir for binaries,
configLibDir :: (Maybe FilePath) | installation dir for object code libraries,
configLibSubDir :: (Maybe FilePath) | subdirectory of libdir in which libs are installed
configLibExecDir :: (Maybe FilePath) | installation dir for program executables,
configDataDir :: (Maybe FilePath) | installation dir for read-only arch-independent data,
configDataSubDir :: (Maybe FilePath) | subdirectory of datadir in which data files are installed
configVerbose :: Int | verbosity level

configUser :: Bool

- -user flag?

configGHCiLib :: Bool | Enable compiling library for GHCi

emptyConfigFlags :: ProgramConfiguration -> ConfigFlags
configureArgs :: ConfigFlags -> [String]
Arguments to pass to a `configure` script, e.g. generated by `autoconf`.
type CopyFlags = (CopyDest, Int)
Flags to `copy`: (destdir, copy-prefix (backwards compat), verbose)
data CopyDest

Constructors

NoCopyDest |
CopyTo FilePath |
CopyPrefix FilePath |

Instances

Eq CopyDest
Show CopyDest

type InstallFlags = (InstallUserFlag, Int)
Flags to `install`: (user package, verbose)
type RegisterFlags = (Bool, Bool, Int)
Flags to `register` and `unregister`: (user package, gen-script, verbose)
type SDistFlags = (Bool, Int)
Flags to `sdist`: (snapshot, verbose)
data InstallUserFlag

Constructors

InstallUserNone | no --user OR --global flag.

InstallUserUser

- -user flag

InstallUserGlobal

- -global flag

parseGlobalArgs :: ProgramConfiguration -> [String] -> IO (Action, [String])
defaultCompilerFlavor :: Maybe CompilerFlavor
parseConfigureArgs :: ProgramConfiguration -> ConfigFlags -> [String] -> [OptDescr a] -> IO (ConfigFlags, [a], [String])
parseBuildArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseCleanArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseHaddockArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseProgramaticaArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseTestArgs :: [String] -> [OptDescr a] -> IO (Int, [a], [String])
parseInstallArgs :: InstallFlags -> [String] -> [OptDescr a] -> IO (InstallFlags, [a], [String])
parseSDistArgs :: [String] -> [OptDescr a] -> IO (SDistFlags, [a], [String])
parseRegisterArgs :: RegisterFlags -> [String] -> [OptDescr a] -> IO (RegisterFlags, [a], [String])
parseUnregisterArgs :: RegisterFlags -> [String] -> [OptDescr a] -> IO (RegisterFlags, [a], [String])
parseCopyArgs :: CopyFlags -> [String] -> [OptDescr a] -> IO (CopyFlags, [a], [String])
reqPathArg :: (FilePath -> a) -> ArgDescr a
reqDirArg :: (FilePath -> a) -> ArgDescr a
Produced by Haddock version 0.7